/*
Copyright The KCP Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"net/http"

	logicalcluster "github.com/kcp-dev/apimachinery/pkg/logicalcluster"

	rest "k8s.io/client-go/rest"

	v1alpha1 "github.com/kcp-dev/kcp/pkg/apis/apis/v1alpha1"
	"github.com/kcp-dev/kcp/pkg/client/clientset/versioned/scheme"
)

type ApisV1alpha1Interface interface {
	RESTClient() rest.Interface
	APIBindingsGetter
	APIExportsGetter
	APIResourceSchemasGetter
}

// ApisV1alpha1Client is used to interact with features provided by the apis.kcp.dev group.
type ApisV1alpha1Client struct {
	restClient rest.Interface
	cluster    logicalcluster.LogicalCluster
}

func (c *ApisV1alpha1Client) APIBindings() APIBindingInterface {
	return newAPIBindings(c)
}

func (c *ApisV1alpha1Client) APIExports() APIExportInterface {
	return newAPIExports(c)
}

func (c *ApisV1alpha1Client) APIResourceSchemas() APIResourceSchemaInterface {
	return newAPIResourceSchemas(c)
}

// NewForConfig creates a new ApisV1alpha1Client for the given config.
// NewForConfig is equivalent to NewForConfigAndClient(c, httpClient),
// where httpClient was generated with rest.HTTPClientFor(c).
func NewForConfig(c *rest.Config) (*ApisV1alpha1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	httpClient, err := rest.HTTPClientFor(&config)
	if err != nil {
		return nil, err
	}
	return NewForConfigAndClient(&config, httpClient)
}

// NewForConfigAndClient creates a new ApisV1alpha1Client for the given config and http client.
// Note the http client provided takes precedence over the configured transport values.
func NewForConfigAndClient(c *rest.Config, h *http.Client) (*ApisV1alpha1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientForConfigAndClient(&config, h)
	if err != nil {
		return nil, err
	}
	return &ApisV1alpha1Client{restClient: client}, nil
}

// NewForConfigOrDie creates a new ApisV1alpha1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *ApisV1alpha1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new ApisV1alpha1Client for the given RESTClient.
func New(c rest.Interface) *ApisV1alpha1Client {
	return &ApisV1alpha1Client{restClient: c}
}

// NewWithCluster creates a new ApisV1alpha1Client for the given RESTClient and cluster.
func NewWithCluster(c rest.Interface, cluster logicalcluster.LogicalCluster) *ApisV1alpha1Client {
	return &ApisV1alpha1Client{restClient: c, cluster: cluster}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1alpha1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *ApisV1alpha1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
